Index: scripts/unify-sources.sh
===================================================================
--- scripts/unify-sources.sh	(revision 554)
+++ scripts/unify-sources.sh	(revision 396)
@@ -89,10 +89,5 @@
     if [ "$3" == 'tabs' ]
     then
-        if echo $2 | grep -q -v -E 'Makefile\.am$'
-        then
-            PATTERN=$(echo -e '\t')
-        else
-            PATTERN='        '
-        fi
+        PATTERN=$(echo -e '\t')
     elif [ "$3" == 'trailing spaces' ]
     then
Index: test/CMakeLists.txt
===================================================================
--- test/CMakeLists.txt	(revision 594)
+++ test/CMakeLists.txt	(revision 601)
@@ -1,5 +1,5 @@
 INCLUDE_DIRECTORIES(
-  ${PROJECT_SOURCE_DIR}
-  ${PROJECT_BINARY_DIR}
+  ${CMAKE_SOURCE_DIR}
+  ${CMAKE_BINARY_DIR}
 )
 
@@ -8,5 +8,5 @@
 ENDIF(HAVE_GLPK)
 
-LINK_DIRECTORIES(${PROJECT_BINARY_DIR}/lemon)
+LINK_DIRECTORIES(${CMAKE_BINARY_DIR}/lemon)
 
 SET(TESTS
@@ -22,5 +22,4 @@
   error_test
   euler_test
-  gomory_hu_test
   graph_copy_test
   graph_test
@@ -30,6 +29,7 @@
   kruskal_test
   maps_test
-  matching_test
+  max_matching_test
   min_cost_arborescence_test
+  min_cost_flow_test
   path_test
   preflow_test
Index: test/Makefile.am
===================================================================
--- test/Makefile.am	(revision 594)
+++ test/Makefile.am	(revision 601)
@@ -18,5 +18,4 @@
 	test/error_test \
 	test/euler_test \
-	test/gomory_hu_test \
 	test/graph_copy_test \
 	test/graph_test \
@@ -26,6 +25,7 @@
 	test/kruskal_test \
 	test/maps_test \
-	test/matching_test \
+	test/max_matching_test \
 	test/min_cost_arborescence_test \
+	test/min_cost_flow_test \
 	test/path_test \
 	test/preflow_test \
@@ -37,6 +37,4 @@
 	test/time_measure_test \
 	test/unionfind_test
-
-test_test_tools_pass_DEPENDENCIES = demo
 
 if HAVE_LP
@@ -61,5 +59,4 @@
 test_error_test_SOURCES = test/error_test.cc
 test_euler_test_SOURCES = test/euler_test.cc
-test_gomory_hu_test_SOURCES = test/gomory_hu_test.cc
 test_graph_copy_test_SOURCES = test/graph_copy_test.cc
 test_graph_test_SOURCES = test/graph_test.cc
@@ -71,6 +68,7 @@
 test_maps_test_SOURCES = test/maps_test.cc
 test_mip_test_SOURCES = test/mip_test.cc
-test_matching_test_SOURCES = test/matching_test.cc
+test_max_matching_test_SOURCES = test/max_matching_test.cc
 test_min_cost_arborescence_test_SOURCES = test/min_cost_arborescence_test.cc
+test_min_cost_flow_test_SOURCES = test/min_cost_flow_test.cc
 test_path_test_SOURCES = test/path_test.cc
 test_preflow_test_SOURCES = test/preflow_test.cc
Index: test/bfs_test.cc
===================================================================
--- test/bfs_test.cc	(revision 585)
+++ test/bfs_test.cc	(revision 440)
@@ -59,16 +59,14 @@
 
   Digraph G;
-  Node s, t, n;
+  Node s, t;
   Arc e;
-  int l, i;
+  int l;
   bool b;
   BType::DistMap d(G);
   BType::PredMap p(G);
   Path<Digraph> pp;
-  concepts::ReadMap<Node,bool> nm;
 
   {
     BType bfs_test(G);
-    const BType& const_bfs_test = bfs_test;
 
     bfs_test.run(s);
@@ -76,24 +74,11 @@
     bfs_test.run();
 
-    bfs_test.init();
-    bfs_test.addSource(s);
-    n = bfs_test.processNextNode();
-    n = bfs_test.processNextNode(t, b);
-    n = bfs_test.processNextNode(nm, n);
-    n = const_bfs_test.nextNode();
-    b = const_bfs_test.emptyQueue();
-    i = const_bfs_test.queueSize();
-    
-    bfs_test.start();
-    bfs_test.start(t);
-    bfs_test.start(nm);
-
-    l  = const_bfs_test.dist(t);
-    e  = const_bfs_test.predArc(t);
-    s  = const_bfs_test.predNode(t);
-    b  = const_bfs_test.reached(t);
-    d  = const_bfs_test.distMap();
-    p  = const_bfs_test.predMap();
-    pp = const_bfs_test.path(t);
+    l  = bfs_test.dist(t);
+    e  = bfs_test.predArc(t);
+    s  = bfs_test.predNode(t);
+    b  = bfs_test.reached(t);
+    d  = bfs_test.distMap();
+    p  = bfs_test.predMap();
+    pp = bfs_test.path(t);
   }
   {
@@ -102,35 +87,11 @@
       ::SetDistMap<concepts::ReadWriteMap<Node,int> >
       ::SetReachedMap<concepts::ReadWriteMap<Node,bool> >
+      ::SetProcessedMap<concepts::WriteMap<Node,bool> >
       ::SetStandardProcessedMap
-      ::SetProcessedMap<concepts::WriteMap<Node,bool> >
       ::Create bfs_test(G);
-      
-    concepts::ReadWriteMap<Node,Arc> pred_map;
-    concepts::ReadWriteMap<Node,int> dist_map;
-    concepts::ReadWriteMap<Node,bool> reached_map;
-    concepts::WriteMap<Node,bool> processed_map;
-    
-    bfs_test
-      .predMap(pred_map)
-      .distMap(dist_map)
-      .reachedMap(reached_map)
-      .processedMap(processed_map);
 
     bfs_test.run(s);
     bfs_test.run(s,t);
     bfs_test.run();
-    
-    bfs_test.init();
-    bfs_test.addSource(s);
-    n = bfs_test.processNextNode();
-    n = bfs_test.processNextNode(t, b);
-    n = bfs_test.processNextNode(nm, n);
-    n = bfs_test.nextNode();
-    b = bfs_test.emptyQueue();
-    i = bfs_test.queueSize();
-    
-    bfs_test.start();
-    bfs_test.start(t);
-    bfs_test.start(nm);
 
     l  = bfs_test.dist(t);
Index: test/circulation_test.cc
===================================================================
--- test/circulation_test.cc	(revision 585)
+++ test/circulation_test.cc	(revision 440)
@@ -72,20 +72,16 @@
   FlowMap flow;
   BarrierMap bar;
-  VType v;
-  bool b;
 
-  typedef Circulation<Digraph, CapMap, CapMap, DeltaMap>
-            ::SetFlowMap<FlowMap>
-            ::SetElevator<Elev>
-            ::SetStandardElevator<LinkedElev>
-            ::Create CirculationType;
-  CirculationType circ_test(g, lcap, ucap, delta);
-  const CirculationType& const_circ_test = circ_test;
-   
-  circ_test
-    .lowerCapMap(lcap)
-    .upperCapMap(ucap)
-    .deltaMap(delta)
-    .flowMap(flow);
+  Circulation<Digraph, CapMap, CapMap, DeltaMap>
+    ::SetFlowMap<FlowMap>
+    ::SetElevator<Elev>
+    ::SetStandardElevator<LinkedElev>
+    ::Create circ_test(g,lcap,ucap,delta);
+
+  circ_test.lowerCapMap(lcap);
+  circ_test.upperCapMap(ucap);
+  circ_test.deltaMap(delta);
+  flow = circ_test.flowMap();
+  circ_test.flowMap(flow);
 
   circ_test.init();
@@ -94,10 +90,7 @@
   circ_test.run();
 
-  v = const_circ_test.flow(a);
-  const FlowMap& fm = const_circ_test.flowMap();
-  b = const_circ_test.barrier(n);
-  const_circ_test.barrierMap(bar);
-  
-  ignore_unused_variable_warning(fm);
+  circ_test.barrier(n);
+  circ_test.barrierMap(bar);
+  circ_test.flow(a);
 }
 
Index: test/counter_test.cc
===================================================================
--- test/counter_test.cc	(revision 558)
+++ test/counter_test.cc	(revision 440)
@@ -19,7 +19,4 @@
 #include <lemon/counter.h>
 #include <vector>
-#include <sstream>
-
-#include "test/test_tools.h"
 
 using namespace lemon;
@@ -27,76 +24,52 @@
 template <typename T>
 void bubbleSort(std::vector<T>& v) {
-  std::stringstream s1, s2, s3;
-  {
-    Counter op("Bubble Sort - Operations: ", s1);
-    Counter::SubCounter as(op, "Assignments: ", s2);
-    Counter::SubCounter co(op, "Comparisons: ", s3);
-    for (int i = v.size()-1; i > 0; --i) {
-      for (int j = 0; j < i; ++j) {
-        if (v[j] > v[j+1]) {
-          T tmp = v[j];
-          v[j] = v[j+1];
-          v[j+1] = tmp;
-          as += 3;
-        }
-        ++co;
+  Counter op("Bubble Sort - Operations: ");
+  Counter::NoSubCounter as(op, "Assignments: ");
+  Counter::NoSubCounter co(op, "Comparisons: ");
+  for (int i = v.size()-1; i > 0; --i) {
+    for (int j = 0; j < i; ++j) {
+      if (v[j] > v[j+1]) {
+        T tmp = v[j];
+        v[j] = v[j+1];
+        v[j+1] = tmp;
+        as += 3;
       }
+      ++co;
     }
   }
-  check(s1.str() == "Bubble Sort - Operations: 102\n", "Wrong counter");
-  check(s2.str() == "Assignments: 57\n", "Wrong subcounter");
-  check(s3.str() == "Comparisons: 45\n", "Wrong subcounter");
 }
 
 template <typename T>
 void insertionSort(std::vector<T>& v) {
-  std::stringstream s1, s2, s3;
-  {
-    Counter op("Insertion Sort - Operations: ", s1);
-    Counter::SubCounter as(op, "Assignments: ", s2);
-    Counter::SubCounter co(op, "Comparisons: ", s3);
-    for (int i = 1; i < int(v.size()); ++i) {
-      T value = v[i];
-      ++as;
-      int j = i;
-      while (j > 0 && v[j-1] > value) {
-        v[j] = v[j-1];
-        --j;
-        ++co; ++as;
-      }
-      v[j] = value;
-      ++as;
+  Counter op("Insertion Sort - Operations: ");
+  Counter::NoSubCounter as(op, "Assignments: ");
+  Counter::NoSubCounter co(op, "Comparisons: ");
+  for (int i = 1; i < int(v.size()); ++i) {
+    T value = v[i];
+    ++as;
+    int j = i;
+    while (j > 0 && v[j-1] > value) {
+      v[j] = v[j-1];
+      --j;
+      ++co; ++as;
     }
+    v[j] = value;
+    ++as;
   }
-  check(s1.str() == "Insertion Sort - Operations: 56\n", "Wrong counter");
-  check(s2.str() == "Assignments: 37\n", "Wrong subcounter");
-  check(s3.str() == "Comparisons: 19\n", "Wrong subcounter");
 }
 
 template <typename MyCounter>
-void counterTest(bool output) {
-  std::stringstream s1, s2, s3;
-  {
-    MyCounter c("Main Counter: ", s1);
-    c++;
-    typename MyCounter::SubCounter d(c, "SubCounter: ", s2);
-    d++;
-    typename MyCounter::SubCounter::NoSubCounter e(d, "SubSubCounter: ", s3);
-    e++;
-    d+=3;
-    c-=4;
-    e-=2;
-    c.reset(2);
-    c.reset();
-  }
-  if (output) {
-    check(s1.str() == "Main Counter: 3\n", "Wrong Counter");
-    check(s2.str() == "SubCounter: 3\n", "Wrong SubCounter");
-    check(s3.str() == "", "Wrong NoSubCounter");
-  } else {
-    check(s1.str() == "", "Wrong NoCounter");
-    check(s2.str() == "", "Wrong SubCounter");
-    check(s3.str() == "", "Wrong NoSubCounter");
-  }
+void counterTest() {
+  MyCounter c("Main Counter: ");
+  c++;
+  typename MyCounter::SubCounter d(c, "SubCounter: ");
+  d++;
+  typename MyCounter::SubCounter::NoSubCounter e(d, "SubSubCounter: ");
+  e++;
+  d+=3;
+  c-=4;
+  e-=2;
+  c.reset(2);
+  c.reset();
 }
 
@@ -108,6 +81,6 @@
 int main()
 {
-  counterTest<Counter>(true);
-  counterTest<NoCounter>(false);
+  counterTest<Counter>();
+  counterTest<NoCounter>();
 
   std::vector<int> x(10);
Index: test/dfs_test.cc
===================================================================
--- test/dfs_test.cc	(revision 585)
+++ test/dfs_test.cc	(revision 440)
@@ -63,14 +63,12 @@
   Node s, t;
   Arc e;
-  int l, i;
+  int l;
   bool b;
   DType::DistMap d(G);
   DType::PredMap p(G);
   Path<Digraph> pp;
-  concepts::ReadMap<Arc,bool> am;
 
   {
     DType dfs_test(G);
-    const DType& const_dfs_test = dfs_test;
 
     dfs_test.run(s);
@@ -78,22 +76,11 @@
     dfs_test.run();
 
-    dfs_test.init();
-    dfs_test.addSource(s);
-    e = dfs_test.processNextArc();
-    e = const_dfs_test.nextArc();
-    b = const_dfs_test.emptyQueue();
-    i = const_dfs_test.queueSize();
-    
-    dfs_test.start();
-    dfs_test.start(t);
-    dfs_test.start(am);
-
-    l  = const_dfs_test.dist(t);
-    e  = const_dfs_test.predArc(t);
-    s  = const_dfs_test.predNode(t);
-    b  = const_dfs_test.reached(t);
-    d  = const_dfs_test.distMap();
-    p  = const_dfs_test.predMap();
-    pp = const_dfs_test.path(t);
+    l  = dfs_test.dist(t);
+    e  = dfs_test.predArc(t);
+    s  = dfs_test.predNode(t);
+    b  = dfs_test.reached(t);
+    d  = dfs_test.distMap();
+    p  = dfs_test.predMap();
+    pp = dfs_test.path(t);
   }
   {
@@ -102,33 +89,11 @@
       ::SetDistMap<concepts::ReadWriteMap<Node,int> >
       ::SetReachedMap<concepts::ReadWriteMap<Node,bool> >
+      ::SetProcessedMap<concepts::WriteMap<Node,bool> >
       ::SetStandardProcessedMap
-      ::SetProcessedMap<concepts::WriteMap<Node,bool> >
       ::Create dfs_test(G);
-
-    concepts::ReadWriteMap<Node,Arc> pred_map;
-    concepts::ReadWriteMap<Node,int> dist_map;
-    concepts::ReadWriteMap<Node,bool> reached_map;
-    concepts::WriteMap<Node,bool> processed_map;
-    
-    dfs_test
-      .predMap(pred_map)
-      .distMap(dist_map)
-      .reachedMap(reached_map)
-      .processedMap(processed_map);
 
     dfs_test.run(s);
     dfs_test.run(s,t);
     dfs_test.run();
-    dfs_test.init();
-
-    dfs_test.addSource(s);
-    e = dfs_test.processNextArc();
-    e = dfs_test.nextArc();
-    b = dfs_test.emptyQueue();
-    i = dfs_test.queueSize();
-    
-    dfs_test.start();
-    dfs_test.start(t);
-    dfs_test.start(am);
 
     l  = dfs_test.dist(t);
Index: test/dijkstra_test.cc
===================================================================
--- test/dijkstra_test.cc	(revision 585)
+++ test/dijkstra_test.cc	(revision 440)
@@ -61,8 +61,7 @@
 
   Digraph G;
-  Node s, t, n;
+  Node s, t;
   Arc e;
   VType l;
-  int i;
   bool b;
   DType::DistMap d(G);
@@ -70,34 +69,18 @@
   LengthMap length;
   Path<Digraph> pp;
-  concepts::ReadMap<Node,bool> nm;
 
   {
     DType dijkstra_test(G,length);
-    const DType& const_dijkstra_test = dijkstra_test;
 
     dijkstra_test.run(s);
     dijkstra_test.run(s,t);
 
-    dijkstra_test.init();
-    dijkstra_test.addSource(s);
-    dijkstra_test.addSource(s, 1);
-    n = dijkstra_test.processNextNode();
-    n = const_dijkstra_test.nextNode();
-    b = const_dijkstra_test.emptyQueue();
-    i = const_dijkstra_test.queueSize();
-    
-    dijkstra_test.start();
-    dijkstra_test.start(t);
-    dijkstra_test.start(nm);
-
-    l  = const_dijkstra_test.dist(t);
-    e  = const_dijkstra_test.predArc(t);
-    s  = const_dijkstra_test.predNode(t);
-    b  = const_dijkstra_test.reached(t);
-    b  = const_dijkstra_test.processed(t);
-    d  = const_dijkstra_test.distMap();
-    p  = const_dijkstra_test.predMap();
-    pp = const_dijkstra_test.path(t);
-    l  = const_dijkstra_test.currentDist(t);
+    l  = dijkstra_test.dist(t);
+    e  = dijkstra_test.predArc(t);
+    s  = dijkstra_test.predNode(t);
+    b  = dijkstra_test.reached(t);
+    d  = dijkstra_test.distMap();
+    p  = dijkstra_test.predMap();
+    pp = dijkstra_test.path(t);
   }
   {
@@ -105,40 +88,13 @@
       ::SetPredMap<concepts::ReadWriteMap<Node,Arc> >
       ::SetDistMap<concepts::ReadWriteMap<Node,VType> >
+      ::SetProcessedMap<concepts::WriteMap<Node,bool> >
       ::SetStandardProcessedMap
-      ::SetProcessedMap<concepts::WriteMap<Node,bool> >
       ::SetOperationTraits<DijkstraDefaultOperationTraits<VType> >
       ::SetHeap<BinHeap<VType, concepts::ReadWriteMap<Node,int> > >
       ::SetStandardHeap<BinHeap<VType, concepts::ReadWriteMap<Node,int> > >
-      ::SetHeap<BinHeap<VType, concepts::ReadWriteMap<Node,int> >, 
-                concepts::ReadWriteMap<Node,int> >
       ::Create dijkstra_test(G,length);
-
-    LengthMap length_map;
-    concepts::ReadWriteMap<Node,Arc> pred_map;
-    concepts::ReadWriteMap<Node,VType> dist_map;
-    concepts::WriteMap<Node,bool> processed_map;
-    concepts::ReadWriteMap<Node,int> heap_cross_ref;
-    BinHeap<VType, concepts::ReadWriteMap<Node,int> > heap(heap_cross_ref);
-    
-    dijkstra_test
-      .lengthMap(length_map)
-      .predMap(pred_map)
-      .distMap(dist_map)
-      .processedMap(processed_map)
-      .heap(heap, heap_cross_ref);
 
     dijkstra_test.run(s);
     dijkstra_test.run(s,t);
-
-    dijkstra_test.addSource(s);
-    dijkstra_test.addSource(s, 1);
-    n = dijkstra_test.processNextNode();
-    n = dijkstra_test.nextNode();
-    b = dijkstra_test.emptyQueue();
-    i = dijkstra_test.queueSize();
-    
-    dijkstra_test.start();
-    dijkstra_test.start(t);
-    dijkstra_test.start(nm);
 
     l  = dijkstra_test.dist(t);
@@ -146,7 +102,5 @@
     s  = dijkstra_test.predNode(t);
     b  = dijkstra_test.reached(t);
-    b  = dijkstra_test.processed(t);
     pp = dijkstra_test.path(t);
-    l  = dijkstra_test.currentDist(t);
   }
 
Index: test/euler_test.cc
===================================================================
--- test/euler_test.cc	(revision 592)
+++ test/euler_test.cc	(revision 531)
@@ -19,64 +19,61 @@
 #include <lemon/euler.h>
 #include <lemon/list_graph.h>
-#include <lemon/adaptors.h>
-#include "test_tools.h"
+#include <test/test_tools.h>
 
 using namespace lemon;
 
 template <typename Digraph>
-void checkDiEulerIt(const Digraph& g,
-                    const typename Digraph::Node& start = INVALID)
+void checkDiEulerIt(const Digraph& g)
 {
   typename Digraph::template ArcMap<int> visitationNumber(g, 0);
 
-  DiEulerIt<Digraph> e(g, start);
-  if (e == INVALID) return;
+  DiEulerIt<Digraph> e(g);
   typename Digraph::Node firstNode = g.source(e);
   typename Digraph::Node lastNode = g.target(e);
-  if (start != INVALID) {
-    check(firstNode == start, "checkDiEulerIt: Wrong first node");
-  }
 
-  for (; e != INVALID; ++e) {
-    if (e != INVALID) lastNode = g.target(e);
+  for (; e != INVALID; ++e)
+  {
+    if (e != INVALID)
+    {
+      lastNode = g.target(e);
+    }
     ++visitationNumber[e];
   }
 
   check(firstNode == lastNode,
-      "checkDiEulerIt: First and last nodes are not the same");
+      "checkDiEulerIt: first and last node are not the same");
 
   for (typename Digraph::ArcIt a(g); a != INVALID; ++a)
   {
     check(visitationNumber[a] == 1,
-        "checkDiEulerIt: Not visited or multiple times visited arc found");
+        "checkDiEulerIt: not visited or multiple times visited arc found");
   }
 }
 
 template <typename Graph>
-void checkEulerIt(const Graph& g,
-                  const typename Graph::Node& start = INVALID)
+void checkEulerIt(const Graph& g)
 {
   typename Graph::template EdgeMap<int> visitationNumber(g, 0);
 
-  EulerIt<Graph> e(g, start);
-  if (e == INVALID) return;
-  typename Graph::Node firstNode = g.source(typename Graph::Arc(e));
-  typename Graph::Node lastNode = g.target(typename Graph::Arc(e));
-  if (start != INVALID) {
-    check(firstNode == start, "checkEulerIt: Wrong first node");
-  }
+  EulerIt<Graph> e(g);
+  typename Graph::Node firstNode = g.u(e);
+  typename Graph::Node lastNode = g.v(e);
 
-  for (; e != INVALID; ++e) {
-    if (e != INVALID) lastNode = g.target(typename Graph::Arc(e));
+  for (; e != INVALID; ++e)
+  {
+    if (e != INVALID)
+    {
+      lastNode = g.v(e);
+    }
     ++visitationNumber[e];
   }
 
   check(firstNode == lastNode,
-      "checkEulerIt: First and last nodes are not the same");
+      "checkEulerIt: first and last node are not the same");
 
   for (typename Graph::EdgeIt e(g); e != INVALID; ++e)
   {
     check(visitationNumber[e] == 1,
-        "checkEulerIt: Not visited or multiple times visited edge found");
+        "checkEulerIt: not visited or multiple times visited edge found");
   }
 }
@@ -85,138 +82,71 @@
 {
   typedef ListDigraph Digraph;
-  typedef Undirector<Digraph> Graph;
-  
+  typedef ListGraph Graph;
+
+  Digraph digraphWithEulerianCircuit;
   {
-    Digraph d;
-    Graph g(d);
-    
-    checkDiEulerIt(d);
-    checkDiEulerIt(g);
-    checkEulerIt(g);
+    Digraph& g = digraphWithEulerianCircuit;
 
-    check(eulerian(d), "This graph is Eulerian");
-    check(eulerian(g), "This graph is Eulerian");
+    Digraph::Node n0 = g.addNode();
+    Digraph::Node n1 = g.addNode();
+    Digraph::Node n2 = g.addNode();
+
+    g.addArc(n0, n1);
+    g.addArc(n1, n0);
+    g.addArc(n1, n2);
+    g.addArc(n2, n1);
   }
+
+  Digraph digraphWithoutEulerianCircuit;
   {
-    Digraph d;
-    Graph g(d);
-    Digraph::Node n = d.addNode();
+    Digraph& g = digraphWithoutEulerianCircuit;
 
-    checkDiEulerIt(d);
-    checkDiEulerIt(g);
-    checkEulerIt(g);
+    Digraph::Node n0 = g.addNode();
+    Digraph::Node n1 = g.addNode();
+    Digraph::Node n2 = g.addNode();
 
-    check(eulerian(d), "This graph is Eulerian");
-    check(eulerian(g), "This graph is Eulerian");
+    g.addArc(n0, n1);
+    g.addArc(n1, n0);
+    g.addArc(n1, n2);
   }
+
+  Graph graphWithEulerianCircuit;
   {
-    Digraph d;
-    Graph g(d);
-    Digraph::Node n = d.addNode();
-    d.addArc(n, n);
+    Graph& g = graphWithEulerianCircuit;
 
-    checkDiEulerIt(d);
-    checkDiEulerIt(g);
-    checkEulerIt(g);
+    Graph::Node n0 = g.addNode();
+    Graph::Node n1 = g.addNode();
+    Graph::Node n2 = g.addNode();
 
-    check(eulerian(d), "This graph is Eulerian");
-    check(eulerian(g), "This graph is Eulerian");
+    g.addEdge(n0, n1);
+    g.addEdge(n1, n2);
+    g.addEdge(n2, n0);
   }
+
+  Graph graphWithoutEulerianCircuit;
   {
-    Digraph d;
-    Graph g(d);
-    Digraph::Node n1 = d.addNode();
-    Digraph::Node n2 = d.addNode();
-    Digraph::Node n3 = d.addNode();
-    
-    d.addArc(n1, n2);
-    d.addArc(n2, n1);
-    d.addArc(n2, n3);
-    d.addArc(n3, n2);
+    Graph& g = graphWithoutEulerianCircuit;
 
-    checkDiEulerIt(d);
-    checkDiEulerIt(d, n2);
-    checkDiEulerIt(g);
-    checkDiEulerIt(g, n2);
-    checkEulerIt(g);
-    checkEulerIt(g, n2);
+    Graph::Node n0 = g.addNode();
+    Graph::Node n1 = g.addNode();
+    Graph::Node n2 = g.addNode();
 
-    check(eulerian(d), "This graph is Eulerian");
-    check(eulerian(g), "This graph is Eulerian");
+    g.addEdge(n0, n1);
+    g.addEdge(n1, n2);
   }
-  {
-    Digraph d;
-    Graph g(d);
-    Digraph::Node n1 = d.addNode();
-    Digraph::Node n2 = d.addNode();
-    Digraph::Node n3 = d.addNode();
-    Digraph::Node n4 = d.addNode();
-    Digraph::Node n5 = d.addNode();
-    Digraph::Node n6 = d.addNode();
-    
-    d.addArc(n1, n2);
-    d.addArc(n2, n4);
-    d.addArc(n1, n3);
-    d.addArc(n3, n4);
-    d.addArc(n4, n1);
-    d.addArc(n3, n5);
-    d.addArc(n5, n2);
-    d.addArc(n4, n6);
-    d.addArc(n2, n6);
-    d.addArc(n6, n1);
-    d.addArc(n6, n3);
 
-    checkDiEulerIt(d);
-    checkDiEulerIt(d, n1);
-    checkDiEulerIt(d, n5);
+  checkDiEulerIt(digraphWithEulerianCircuit);
 
-    checkDiEulerIt(g);
-    checkDiEulerIt(g, n1);
-    checkDiEulerIt(g, n5);
-    checkEulerIt(g);
-    checkEulerIt(g, n1);
-    checkEulerIt(g, n5);
+  checkEulerIt(graphWithEulerianCircuit);
 
-    check(eulerian(d), "This graph is Eulerian");
-    check(eulerian(g), "This graph is Eulerian");
-  }
-  {
-    Digraph d;
-    Graph g(d);
-    Digraph::Node n0 = d.addNode();
-    Digraph::Node n1 = d.addNode();
-    Digraph::Node n2 = d.addNode();
-    Digraph::Node n3 = d.addNode();
-    Digraph::Node n4 = d.addNode();
-    Digraph::Node n5 = d.addNode();
-    
-    d.addArc(n1, n2);
-    d.addArc(n2, n3);
-    d.addArc(n3, n1);
+  check(eulerian(digraphWithEulerianCircuit),
+      "this graph should have an Eulerian circuit");
+  check(!eulerian(digraphWithoutEulerianCircuit),
+      "this graph should not have an Eulerian circuit");
 
-    checkDiEulerIt(d);
-    checkDiEulerIt(d, n2);
-
-    checkDiEulerIt(g);
-    checkDiEulerIt(g, n2);
-    checkEulerIt(g);
-    checkEulerIt(g, n2);
-
-    check(!eulerian(d), "This graph is not Eulerian");
-    check(!eulerian(g), "This graph is not Eulerian");
-  }
-  {
-    Digraph d;
-    Graph g(d);
-    Digraph::Node n1 = d.addNode();
-    Digraph::Node n2 = d.addNode();
-    Digraph::Node n3 = d.addNode();
-    
-    d.addArc(n1, n2);
-    d.addArc(n2, n3);
-
-    check(!eulerian(d), "This graph is not Eulerian");
-    check(!eulerian(g), "This graph is not Eulerian");
-  }
+  check(eulerian(graphWithEulerianCircuit),
+      "this graph should have an Eulerian circuit");
+  check(!eulerian(graphWithoutEulerianCircuit),
+      "this graph should have an Eulerian circuit");
 
   return 0;
Index: test/graph_utils_test.cc
===================================================================
--- test/graph_utils_test.cc	(revision 572)
+++ test/graph_utils_test.cc	(revision 440)
@@ -39,6 +39,6 @@
       digraph.addNode();
     }
-    RangeIdMap<Digraph, Node> nodes(digraph);
-    typename RangeIdMap<Digraph, Node>::InverseMap invNodes(nodes);
+    DescriptorMap<Digraph, Node> nodes(digraph);
+    typename DescriptorMap<Digraph, Node>::InverseMap invNodes(nodes);
     for (int i = 0; i < 100; ++i) {
       int src = rnd[invNodes.size()];
@@ -47,5 +47,5 @@
     }
     typename Digraph::template ArcMap<bool> found(digraph, false);
-    RangeIdMap<Digraph, Arc> arcs(digraph);
+    DescriptorMap<Digraph, Arc> arcs(digraph);
     for (NodeIt src(digraph); src != INVALID; ++src) {
       for (NodeIt trg(digraph); trg != INVALID; ++trg) {
@@ -114,6 +114,6 @@
     graph.addNode();
   }
-  RangeIdMap<Graph, Node> nodes(graph);
-  typename RangeIdMap<Graph, Node>::InverseMap invNodes(nodes);
+  DescriptorMap<Graph, Node> nodes(graph);
+  typename DescriptorMap<Graph, Node>::InverseMap invNodes(nodes);
   for (int i = 0; i < 100; ++i) {
     int src = rnd[invNodes.size()];
@@ -122,5 +122,5 @@
   }
   typename Graph::template EdgeMap<int> found(graph, 0);
-  RangeIdMap<Graph, Edge> edges(graph);
+  DescriptorMap<Graph, Edge> edges(graph);
   for (NodeIt src(graph); src != INVALID; ++src) {
     for (NodeIt trg(graph); trg != INVALID; ++trg) {
Index: test/hao_orlin_test.cc
===================================================================
--- test/hao_orlin_test.cc	(revision 597)
+++ test/hao_orlin_test.cc	(revision 440)
@@ -20,10 +20,7 @@
 
 #include <lemon/smart_graph.h>
-#include <lemon/adaptors.h>
-#include <lemon/concepts/digraph.h>
-#include <lemon/concepts/maps.h>
-#include <lemon/lgf_reader.h>
 #include <lemon/hao_orlin.h>
 
+#include <lemon/lgf_reader.h>
 #include "test_tools.h"
 
@@ -41,122 +38,25 @@
   "5\n"
   "@edges\n"
-  "     cap1 cap2 cap3\n"
-  "0 1  1    1    1   \n"
-  "0 2  2    2    4   \n"
-  "1 2  4    4    4   \n"
-  "3 4  1    1    1   \n"
-  "3 5  2    2    4   \n"
-  "4 5  4    4    4   \n"
-  "5 4  4    4    4   \n"
-  "2 3  1    6    6   \n"
-  "4 0  1    6    6   \n";
-
-void checkHaoOrlinCompile()
-{
-  typedef int Value;
-  typedef concepts::Digraph Digraph;
-
-  typedef Digraph::Node Node;
-  typedef Digraph::Arc Arc;
-  typedef concepts::ReadMap<Arc, Value> CapMap;
-  typedef concepts::WriteMap<Node, bool> CutMap;
-
-  Digraph g;
-  Node n;
-  CapMap cap;
-  CutMap cut;
-  Value v;
-
-  HaoOrlin<Digraph, CapMap> ho_test(g, cap);
-  const HaoOrlin<Digraph, CapMap>&
-    const_ho_test = ho_test;
-
-  ho_test.init();
-  ho_test.init(n);
-  ho_test.calculateOut();
-  ho_test.calculateIn();
-  ho_test.run();
-  ho_test.run(n);
-
-  v = const_ho_test.minCutValue();
-  v = const_ho_test.minCutMap(cut);
-}
-
-template <typename Graph, typename CapMap, typename CutMap>
-typename CapMap::Value 
-  cutValue(const Graph& graph, const CapMap& cap, const CutMap& cut)
-{
-  typename CapMap::Value sum = 0;
-  for (typename Graph::ArcIt a(graph); a != INVALID; ++a) {
-    if (cut[graph.source(a)] && !cut[graph.target(a)])
-      sum += cap[a];
-  }
-  return sum;
-}
+  "     label  capacity\n"
+  "0 1  0      2\n"
+  "1 2  1      2\n"
+  "2 0  2      2\n"
+  "3 4  3      2\n"
+  "4 5  4      2\n"
+  "5 3  5      2\n"
+  "2 3  6      3\n";
 
 int main() {
-  SmartDigraph graph;
-  SmartDigraph::ArcMap<int> cap1(graph), cap2(graph), cap3(graph);
-  SmartDigraph::NodeMap<bool> cut(graph);
+  SmartGraph graph;
+  SmartGraph::EdgeMap<int> capacity(graph);
 
-  istringstream input(lgf);
-  digraphReader(graph, input)
-    .arcMap("cap1", cap1)
-    .arcMap("cap2", cap2)
-    .arcMap("cap3", cap3)
-    .run();
+  istringstream lgfs(lgf);
+  graphReader(graph, lgfs).
+    edgeMap("capacity", capacity).run();
 
-  {
-    HaoOrlin<SmartDigraph> ho(graph, cap1);
-    ho.run();
-    ho.minCutMap(cut);
-    
-    check(ho.minCutValue() == 1, "Wrong cut value");
-    check(ho.minCutValue() == cutValue(graph, cap1, cut), "Wrong cut value");
-  }
-  {
-    HaoOrlin<SmartDigraph> ho(graph, cap2);
-    ho.run();
-    ho.minCutMap(cut);
+  HaoOrlin<SmartGraph, SmartGraph::EdgeMap<int> > ho(graph, capacity);
+  ho.run();
 
-    check(ho.minCutValue() == 1, "Wrong cut value");
-    check(ho.minCutValue() == cutValue(graph, cap2, cut), "Wrong cut value");
-  }
-  {
-    HaoOrlin<SmartDigraph> ho(graph, cap3);
-    ho.run();
-    ho.minCutMap(cut);
-    
-    check(ho.minCutValue() == 1, "Wrong cut value");
-    check(ho.minCutValue() == cutValue(graph, cap3, cut), "Wrong cut value");
-  }
-  
-  typedef Undirector<SmartDigraph> UGraph;
-  UGraph ugraph(graph);
-  
-  {
-    HaoOrlin<UGraph, SmartDigraph::ArcMap<int> > ho(ugraph, cap1);
-    ho.run();
-    ho.minCutMap(cut);
-    
-    check(ho.minCutValue() == 2, "Wrong cut value");
-    check(ho.minCutValue() == cutValue(ugraph, cap1, cut), "Wrong cut value");
-  }
-  {
-    HaoOrlin<UGraph, SmartDigraph::ArcMap<int> > ho(ugraph, cap2);
-    ho.run();
-    ho.minCutMap(cut);
-    
-    check(ho.minCutValue() == 5, "Wrong cut value");
-    check(ho.minCutValue() == cutValue(ugraph, cap2, cut), "Wrong cut value");
-  }
-  {
-    HaoOrlin<UGraph, SmartDigraph::ArcMap<int> > ho(ugraph, cap3);
-    ho.run();
-    ho.minCutMap(cut);
-    
-    check(ho.minCutValue() == 5, "Wrong cut value");
-    check(ho.minCutValue() == cutValue(ugraph, cap3, cut), "Wrong cut value");
-  }
+  check(ho.minCutValue() == 3, "Wrong cut value");
 
   return 0;
Index: test/kruskal_test.cc
===================================================================
--- test/kruskal_test.cc	(revision 581)
+++ test/kruskal_test.cc	(revision 440)
@@ -100,14 +100,14 @@
         "Total cost should be 10");
 
-  edge_cost_map[e1] = -10;
-  edge_cost_map[e2] = -9;
-  edge_cost_map[e3] = -8;
-  edge_cost_map[e4] = -7;
-  edge_cost_map[e5] = -6;
-  edge_cost_map[e6] = -5;
-  edge_cost_map[e7] = -4;
-  edge_cost_map[e8] = -3;
-  edge_cost_map[e9] = -2;
-  edge_cost_map[e10] = -1;
+  edge_cost_map.set(e1, -10);
+  edge_cost_map.set(e2, -9);
+  edge_cost_map.set(e3, -8);
+  edge_cost_map.set(e4, -7);
+  edge_cost_map.set(e5, -6);
+  edge_cost_map.set(e6, -5);
+  edge_cost_map.set(e7, -4);
+  edge_cost_map.set(e8, -3);
+  edge_cost_map.set(e9, -2);
+  edge_cost_map.set(e10, -1);
 
   vector<Edge> tree_edge_vec(5);
Index: test/lp_test.cc
===================================================================
--- test/lp_test.cc	(revision 575)
+++ test/lp_test.cc	(revision 462)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2009
+ * Copyright (C) 2003-2008
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -198,9 +198,4 @@
     check(const_cast<const LpSolver::Expr&>(e)[p2]==0, buf.str());
 
-    //Test for clone/new
-    LP* lpnew = lp.newSolver();
-    LP* lpclone = lp.cloneSolver();
-    delete lpnew;
-    delete lpclone;
 
   }
@@ -253,6 +248,5 @@
   if (stat ==  LpSolver::OPTIMAL) {
     std::ostringstream sbuf;
-    sbuf << "Wrong optimal value (" << lp.primal() <<") with "
-         << lp.solverName() <<"\n     the right optimum is " << exp_opt;
+    sbuf << "Wrong optimal value: the right optimum is " << exp_opt;
     check(std::abs(lp.primal()-exp_opt) < 1e-3, sbuf.str());
   }
@@ -362,17 +356,4 @@
 }
 
-template<class LP>
-void cloneTest()
-{
-  //Test for clone/new
-
-  LP* lp = new LP();
-  LP* lpnew = lp->newSolver();
-  LP* lpclone = lp->cloneSolver();
-  delete lp;
-  delete lpnew;
-  delete lpclone;
-}
-
 int main()
 {
@@ -385,5 +366,4 @@
     lpTest(lp_glpk1);
     aTest(lp_glpk2);
-    cloneTest<GlpkLp>();
   }
 #endif
@@ -394,7 +374,11 @@
     lpTest(lp_cplex1);
     aTest(lp_cplex2);
-    cloneTest<CplexLp>();
   } catch (CplexEnv::LicenseError& error) {
+#ifdef LEMON_FORCE_CPLEX_CHECK
     check(false, error.what());
+#else
+    std::cerr << error.what() << std::endl;
+    std::cerr << "Cplex license check failed, lp check skipped" << std::endl;
+#endif
   }
 #endif
@@ -405,5 +389,4 @@
     lpTest(lp_soplex1);
     aTest(lp_soplex2);
-    cloneTest<SoplexLp>();
   }
 #endif
@@ -414,5 +397,4 @@
     lpTest(lp_clp1);
     aTest(lp_clp2);
-    cloneTest<ClpLp>();
   }
 #endif
